#include "heading.h"

HINSTANCE hInst;

LRESULT CALLBACK WindowFunc(HWND, UINT, WPARAM, LPARAM);
ATOM MyRegisterClass(HINSTANCE);
BOOL InitInstance(HINSTANCE, int);
HWND CreateAToolBar2(HWND);

int WINAPI WinMain(HINSTANCE hThisInst, HINSTANCE hPrevInst, LPSTR lpszArgs, int nWinMode)
{
	MSG Msg;

	/*    */
	if(!MyRegisterClass(hThisInst))  return 0;
	if(!InitInstance(hThisInst,nWinMode))  return 0;
	
	/*     */
	while(GetMessage(&Msg,NULL,0,0))
	{
		TranslateMessage(&Msg);
		DispatchMessage(&Msg);
	}

	return Msg.wParam;
}

ATOM MyRegisterClass(HINSTANCE hThisInst)
{
	TCHAR szClassName[MAX_CLASS_NAME];
	WNDCLASSEX WndClass;

	LoadString(hThisInst,IDS_WinClassName,szClassName,MAX_CLASS_NAME);

	/*    */
	WndClass.cbSize = sizeof(WNDCLASSEX);                         //   WNDCLASSEX
	WndClass.hInstance = hThisInst;                               //   
	WndClass.lpfnWndProc = WindowFunc;                            //  
	WndClass.lpszClassName = szClassName;                         //   
	WndClass.cbClsExtra = 0;                                      //  
	WndClass.cbWndExtra = 0;                                      //  
	WndClass.style = CS_OWNDC|CS_HREDRAW|CS_VREDRAW;              //   
	WndClass.hIcon = LoadIcon(hThisInst,MAKEINTRESOURCE(IDI_ICON1));//  
	WndClass.hIconSm = NULL;                                      //  
	WndClass.hCursor = LoadCursor(NULL,IDC_ARROW);                //  
	WndClass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH); //   
	WndClass.lpszMenuName = MAKEINTRESOURCE(IDC_PROGMENU);        //  

	return RegisterClassEx(&WndClass);
}

BOOL InitInstance(HINSTANCE hThisInst, int nWinMode)
{
	TCHAR szClassName[MAX_CLASS_NAME];
	TCHAR szTitleName[MAX_TITLE_NAME];
	INITCOMMONCONTROLSEX InitCommonControl;
	HWND hWnd;

	hInst = hThisInst;

	LoadString(hThisInst,IDS_WinClassName,szClassName,MAX_CLASS_NAME);
	LoadString(hThisInst,IDS_WinTitleName,szTitleName,MAX_TITLE_NAME);

	/*   */
	hWnd = CreateWindow(szClassName,szTitleName,WS_OVERLAPPEDWINDOW,
			CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
			NULL,NULL,hThisInst,NULL);
	if(!hWnd)  return FALSE;

	InitCommonControl.dwSize = sizeof(INITCOMMONCONTROLSEX);
	InitCommonControl.dwICC = ICC_BAR_CLASSES;
  InitCommonControlsEx(&InitCommonControl);
  CreateStatusWindow(WS_CHILD|WS_VISIBLE,szTitleName,
  		hWnd,ID_StatusBar);

  CreateAToolBar2(hWnd);

	/*   */
	ShowWindow(hWnd,nWinMode);
	UpdateWindow(hWnd);

	return TRUE;
}


HWND CreateAToolBar2(HWND hWndParent)
{
HWND hWndToolbar;
TBADDBITMAP tb;
int index, stdidx;
INITCOMMONCONTROLSEX icex;
RECT Rect;

// Toolbar buttons
TBBUTTON tbButtons [ ] = 
{
{101, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0L, 0},
{STD_FILENEW, IDM_NEW, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
{STD_FILEOPEN, IDM_OPEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
{STD_FILESAVE, IDM_SAVE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
{0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0L, 0},
{/*VIEW_LARGEICONS*/0, IDM_LARGEICON, TBSTATE_ENABLED, TBSTYLE_BUTTON, 
0L, 0},
{/*VIEW_SMALLICONS*/1, IDM_SMALLICON, TBSTATE_ENABLED, TBSTYLE_BUTTON, 
0L, 0},
{/*VIEW_LIST*/2, IDM_LISTVIEW, TBSTATE_ENABLED, TBSTYLE_BUTTON, 
0L, 0},
{/*VIEW_DETAILS*/3, IDM_REPORTVIEW, TBSTATE_ENABLED, TBSTYLE_BUTTON, 
0L, 0},
}; 

// Ensure that the common control DLL is loaded. 
icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
icex.dwICC  = ICC_BAR_CLASSES;
InitCommonControlsEx(&icex);

// Create the toolbar and add the first three buttons and a separator.
hWndToolbar = CreateToolbarEx (hWndParent, 
WS_CHILD | WS_VISIBLE | TBSTYLE_TOOLTIPS,
ID_ToolBar, 15, (HINSTANCE)HINST_COMMCTRL, IDB_STD_SMALL_COLOR, 
tbButtons, 5, 0, 0, 0, 0, sizeof (TBBUTTON));

// Add the next four buttons
tb.hInst = /*HINST_COMMCTRL*/hInst;
tb.nID = /*IDB_VIEW_SMALL_COLOR*/IDB_TOOLBAR;
stdidx = SendMessage (hWndToolbar, TB_ADDBITMAP, 8, (LPARAM)&tb);

for (index = 5; index < 9; index++)
tbButtons[index].iBitmap += stdidx;

SendMessage (hWndToolbar, TB_ADDBUTTONS, 4, (LONG) &tbButtons[5]);
SendMessage(hWndToolbar,TB_AUTOSIZE,0,0);

GetClientRect(hWndToolbar,&Rect);

CreateWindowEx(0L, "Edit", NULL, WS_CHILD | WS_BORDER
   | WS_VISIBLE | ES_LEFT | ES_AUTOVSCROLL | ES_MULTILINE, 
   3, 3, /*cx_edit/90*/90, /*cy_edit/21*/Rect.bottom-6, 
   hWndToolbar, (HMENU) IDM_EDIT, hInst, 0 );

//SendMessage(hWndToolbar,TB_SETEXTENDEDSTYLE,0,TBSTYLE_EX_DRAWDDARROWS);
                     
return hWndToolbar;

} 